<?php

##########################################################################################
# In order to be able to use this script you need to join the merchant program depending on the country where your store is selling the products
#
# AUSTRALIA - http://shopmania.com.au/ (only supporting AUD, NZD datafeeds)
# ARGENTINA - http://www.shopmania.com.ar/ (only supporting ARS, EUR, USD)       *NEW
# BRASIL - http://www.shopmania.com.br/ (only supporting BRL, USD) 
# BULGARY - http://www.shopmania.bg/ (only supporting BGN, EUR, USD)
# CZECH REPUBLIC - http://www.shop-mania.cz/ (only supporting CZK, EUR, USD)		*NEW
# CHILE - http://www.shopmania.cl/ (only supporting CLP, USD, EUR)       *NEW
# CHINA - http://www.shopmania.cn/ (only supporting CNY, USD)       
# DEUTSCHLAND - http://www.shopmania.de/ (only supporting EUR, USD) 
# FRANCE - http://www.shopmania.fr/ (only supporting EUR, USD datafeeds)
# HUNGARY - http://www.shopmania.hu/ (only supporting HUF, EUR, USD datafeeds)
# INDIA - http://www.shopmania.in/ (only supporting INR, USD datafeeds)
# IRELAND - http://www.shopmania.ie/ (only supporting EUR, GBP datafeeds)
# ITALY - http://www.shopmania.it/ (only supporting EUR, USD datafeeds)
# JAPAN - http://www.shopmania.jp/  (only supporting JPY, USD datafeeds)       
# MEXICO - http://www.shopmania.com.mx/ (only supporting MXN (Mexican peso), USD, EUR datafeeds)
# NETHERLANDS - http://www.shopmania.nl/ (only supporting EUR datafeeds)		*NEW
# POLSKA - http://www.shopmania.pl/ (only supporting PLN, EUR, USD) 
# PORTUGAL - http://www.shopmania.pt/ (only supporting EUR, USD) 
# ROMANIA - http://www.shopmania.ro/ (only supporting RON, EUR, USD datafeeds)
# RUSSIA - http://www.shopmania.ru/ (only supporting RUB, EUR, USD)       
# SERBIA - http://www.shopmania.rs/ (only supporting RSD, EUR)		*NEW	
# SLOVAKIA - http://www.shop-mania.sk/ (only supporting EUR, USD)
# SOUTH AFRICA - http://www.shopmania.co.za/ (only supporting ZAR, USD, EUR)       *NEW
# SPAIN - http://www.shopmania.es/ (only supporting EUR datafeeds) 
# SWEDEN - http://www.shopmania.se/ (only supporting SEK, EUR, USD datafeeds)		*NEW
# TURKEY - http://www.shopmania.com.tr/ (only supporting TRY, EUR, USD)
# US - http://www.shopmania.com/ (only supporting USD, CAD datafeeds)
# UK - http://www.shopmania.co.uk/ (only supporting GBP, EUR, USD datafeeds)
#
# Once you join the program and your application is approved you need to place the file on your server and set up the path to the file on the Merchant Interface
# Files will be  retrieved daily from your server having the products listed automatically on ShopMania
# 
# 
# Options
# @url_param taxes=on (on,off) 
# @url_param storetaxes=on (on,off) 
# @url_param discount=on (on,off) 
# @url_param special=on (on,off) 
# @url_param add_vat=off (on,off) 
# @url_param shipping=off (on,off) 
# @url_param add_tagging=on (on,off) 
# @url_param tagging_params=&utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) 
# @url_param description=on (on,off) 
# @url_param image=on (on,off) 
# @url_param specialprice=on (on,off) 
# @url_param sef=off (on,off) 
# @url_param on_stock=off (on,off) 
# @url_param forcepath=off (on,off) 
# @url_param forcefolder= (FORCEFOLDER) 
# @url_param language= (LANGUAGE_CODE) 
# @url_param language_id= (LANGUAGE_ID) 
# @url_param currency= (CURRENCY_CODE) 
#
# 
##########################################################################################

// Current datafeed script version
$script_version = "1.06";

// Print current Script version
if (@$_GET['get'] == "version") {
	echo "<b>Datafeed Sunshop</b> <br />";
	echo "version <b>" . $script_version . "</b><br />";
	exit;
}

if (!ini_get("safe_mode")) {
    set_time_limit(0);
}
ignore_user_abort();
error_reporting(E_ALL^E_NOTICE);
$_SVR = array();

##### Include configuration files ################################################

# You need to do place this file in your root directory, where the global.php file is located.
# Otherwise, if you place this file in another directory please modify the line below with the path to the directory where the global.php file is located.

$site_base_path = "./";
$datafeed_separator = "|";

##### Avoid any modifications below this line #####

// Include configuration file
if(!file_exists($site_base_path . "global.php")) {
	exit('<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Please ensure that datafeed_shopmania_sunshop.php is in the root directory, or make sure the path to the directory where the global file is located is defined corectly above in $site_base_path variable</BODY></HTML>');
}
else {
	include $site_base_path . "global.php";
}

// Get defaul currency
$query_currency_code = mysql_query("SELECT currency FROM " . $dbprefix . "currency WHERE rate='1'") or die("Currency code: " . mysql_error());
$currency_code_row = mysql_fetch_array($query_currency_code);

$datafeed_currency = $currency_code_row['currency'];

##### Extract params from url ################################################

$apply_taxes = (@$_GET['taxes'] == "off") ? "off" : "on";
$apply_storetaxes = (@$_GET['storetaxes'] == "off") ? "off" : "on";
$apply_discount = (@$_GET['discount'] == "off") ? "off" : "on";
$add_vat = (@$_GET['add_vat'] == "on") ? "on" : "off";
$vat_value = (@$_GET['vat_value'] > 0) ? ((100 + $_GET['vat_value']) / 100) : 1.24; // default value
$add_shipping = (@$_GET['shipping'] == "on") ? "on" : "off";
$add_tagging = (@$_GET['add_tagging'] == "off") ? "off" : "on";
$tagging_params = (@$_GET['tagging_params'] != "") ? urldecode($_GET['tagging_params']) : "utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link";
$show_description = (@$_GET['description'] == "off") ? "off" : "on";
$show_image = (@$_GET['image'] == "off") ? "off" : "on";
$show_specialprice = (@$_GET['specialprice'] == "off") ? "off" : "on";
$sef = (@$_GET['sef'] == "on") ? "on" : "off";
$on_stock_only = (@$_GET['on_stock'] == "on") ? "on" : "off";
$language_code = (@$_GET['language'] != "") ? $_GET['language'] : "";
$language_id = (@$_GET['language_id'] != "") ? $_GET['language_id'] : "";
$currency = (@$_GET['currency'] != "") ? $_GET['currency'] : "";
$display_currency = (@$_GET['display_currency'] != "") ? $_GET['display_currency'] : "";
$force_path = (@$_GET['forcepath'] == "on") ? "on" : "off";
$force_folder = (@$_GET['forcefolder'] != "") ? $_GET['forcefolder'] : "";
$force_image_folder = (@$_GET['force_image_folder'] != "") ? $_GET['force_image_folder'] : "products/large";

####################################################################

// Print URL options
if (@$_GET['get'] == "options") {
	$script_basepath = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
	
	echo "<b>Datafeed Sunshop</b> <br />";
	echo "version <b>" . $script_version . "</b><br /><br /><br />";
		
	/*echo "<b>Taxes options</b> - possible values on, off default value on<br />";
	echo "taxes=on (on,off) <a href=\"" . $script_basepath . "?taxes=off" . "\" >" . $script_basepath . "?taxes=off" . "</a><br /><br />";
	
	echo "<b>Store taxes options</b> - possible values on, off default value on<br />";
	echo "storetaxes = on (on,off) <a href=\"" . $script_basepath . "?storetaxes=off" . "\" >" . $script_basepath . "?storetaxes=off" . "</a><br /><br />";
	
	echo "<b>Discount options</b> - possible values on, off default value on<br />";
	echo "discount=on (on,off) <a href=\"" . $script_basepath . "?discount=off" . "\" >" . $script_basepath . "?discount=off" . "</a><br /><br />";
	
	echo "<b>Special price options</b> - possible values on, off default value on<br />";
	echo "special=on (on,off) <a href=\"" . $script_basepath . "?special=off" . "\" >" . $script_basepath . "?special=off" . "</a><br /><br />";
	*/
	echo "<b>Add VAT to prices</b> - possible values on, off default value off<br />";
	echo "add_vat=off (on,off) <a href=\"" . $script_basepath . "?add_vat=on" . "\" >" . $script_basepath . "?add_vat=on" . "</a><br /><br />";
	
	echo "VAT value - possible values percent value default value 24  - interger or float number ex 19 or 19.5<br />";
	echo "vat_value=24 (VAT_VALUE) <a href=\"" . $script_basepath . "?add_vat=on&vat_value=19" . "\" >" . $script_basepath . "?add_vat=on&vat_value=19" . "</a><br /><br />";
		
	//echo "<b>Add shipping to datafeed</b> - possible values on, off default value off<br />";
	//echo "shipping=off (on,off) <a href=\"" . $script_basepath . "?shipping=off" . "\" >" . $script_basepath . "?shipping=off" . "</a><br /><br />";
	
	echo "<b>Add GA Tagging to product URL</b> - possible values on, off default value on<br />";
	echo "add_tagging=on (on,off) <a href=\"" . $script_basepath . "?add_tagging=off" . "\" >" . $script_basepath . "?add_tagging=off" . "</a><br /><br />";
		
	echo "<b>Add custom Tagging to product URL</b> - possible values url_encode(TAGGING_PARAMS) default value tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link<br />";
	echo "tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) <a href=\"" . $script_basepath . "?tagging_params=from%3Dshopmania" . "\" >" . $script_basepath . "?tagging_params=from%3Dshopmania" . "</a><br /><br />";
	
	echo "<b>Display Description options</b> - possible values on, off<br />";
	echo "description=on (on,off) <a href=\"" . $script_basepath . "?description=off" . "\" >" . $script_basepath . "?description=off" . "</a><br /><br />";

	echo "<b>Display image options</b> - possible values on, off default value on<br />";
	echo "image=on (on,off) <a href=\"" . $script_basepath . "?image=off" . "\" >" . $script_basepath . "?image=off" . "</a><br /><br />";
	
	echo "<b>Display currency code</b> - force the display of certain currency code possible values USD,EUR etc. <br />";
	echo "display_currency=DEFAULT_CURRENCY <a href=\"" . $script_basepath . "?display_currency=EUR" . "\" >" . $script_basepath . "?display_currency=EUR" . "</a><br /><br />";
	
	/*echo "<b>Special price options</b> - possible values on, off default value on<br />";
	echo "specialprice=on (on,off) <a href=\"" . $script_basepath . "?specialprice=off" . "\" >" . $script_basepath . "?specialprice=off" . "</a><br /><br />";
	
	echo "<b>Add basepath to product URL</b> - possible values on, off default value off<br />";
	echo "forcepath=off (on,off) <a href=\"" . $script_basepath . "?forcepath=on" . "\" >" . $script_basepath . "?forcepath=on" . "</a><br /><br />";
		
	echo "<b>Get prices in specified currency</b> - possible values USD,EUR etc. <br />";
	echo "currency=DEFAULT_CURRENCY <a href=\"" . $script_basepath . "?currency=EUR" . "\" >" . $script_basepath . "?currency=EUR" . "</a><br /><br />";
	
	echo "<b>Get texts in specified language code</b> - possible values en,ro etc. <br />";
	echo "language=DEFAULT_LANGUAGE_CODE <a href=\"" . $script_basepath . "?language=en" . "\" >" . $script_basepath . "?language=en" . "</a><br /><br />";
	
	echo "<b>Get texts in specified language id</b> - possible values 1,2 etc. <br />";
	echo "language_id=DEFAULT_LANGUAGE_ID <a href=\"" . $script_basepath . "?language_id=1" . "\" >" . $script_basepath . "?language_id=1" . "</a><br /><br />";
	*/	
	exit;
}

##### Extract options from database ################################################

// Force displayed currency
$datafeed_currency = ($display_currency != "") ? $display_currency : $datafeed_currency;

##### Extract products from database ###############################################

$image_field = ($show_image == "on") ? "p.large_image" : "''";
$description_field = ($show_description == "on") ? "p.full_desc" : "''";

$products = $DB_site->query("SELECT p.title AS prod_name, " . $description_field . ", " . $image_field . ", p.price, p.sale_price, p.id AS productid, c.title AS cat_name, m.name AS manufacturer 
FROM `" . $dbprefix . "products` p 
LEFT JOIN `" . $dbprefix . "products_categories` pc ON p.id=pc.productid 
LEFT JOIN `" . $dbprefix . "categories` c ON c.id=pc.catid 
LEFT JOIN `" . $dbprefix . "manufacturers` m ON m.id=p.manufacturer
WHERE p.orderable='y' AND p.viewable='y'
ORDER BY p.id ASC");

$current_id = 0;

while ($row = $DB_site->fetch_assoc($products)) {

		$prod_id = $row['productid'];
		
		// If we've sent this one, skip the rest - this is to ensure that we do not get duplicate products
		if ($current_id == $prod_id) {
			continue;
		}
		else {
			$current_id = $prod_id;
		}

		// Clean description
		$row['full_desc'] = smfeed_clean_description($row['full_desc']);

		// Clean product name (new lines)
		$row['prod_name'] = str_replace("\n", "", strip_tags($row['prod_name']));
		// Clean product description (Replace new line with <BR>). In order to make sure the code does not contains other HTML code it might be a good ideea to strip_tags()
		$row['full_desc'] = smfeed_replace_not_in_tags("\n", "<BR />", $row['full_desc']);
		$row['full_desc'] = str_replace("\n", " ", $row['full_desc']);		
		$row['full_desc'] = str_replace("\r", "", $row['full_desc']);
				
		$row['prod_url'] = smfeed_get_product_url($row['productid']);
		// Add GA Tagging parameters to url
		if ($add_tagging == "on") {
			$and_param = (preg_match("/\?/", $row['prod_url'])) ? "&" : "?";
			$row['prod_url'] = $row['prod_url'] . $and_param . $tagging_params;
		}
		
		$row['prod_image'] = smfeed_get_product_image($row['large_image']);		
		$row['prod_price'] = ($row['sale_price'] > 0 ) ? $row['sale_price'] : $row['price'];
		
		// Add VAT to prices
		if ($add_vat == "on") {
			$row['prod_price'] = ($row['sale_price'] > 0 ) ? $row['sale_price'] : $row['price'];
			$row['prod_price'] = $row['prod_price'] * $vat_value;
		}
		
		// Required fields are: category name, merchant product ID, product name, product URL, product price
		// For the product model you should only use the manufacturer code, ISBN code or UPC code - If you are not sure about a field please leave it empty
		
		// Clean product names and descriptions (separators)
		if ($datafeed_separator == "\t") {
			$row['prod_name'] = str_replace("\t", " ", strip_tags($row['prod_name']));
			$row['full_desc'] = str_replace("\t", " ", $row['full_desc']);
			$row['cat_name'] = str_replace("\t", " ", $row['cat_name']);
		}
		elseif ($datafeed_separator == "|") {
			$row['prod_name'] = str_replace("|", " ", strip_tags($row['prod_name']));
			$row['full_desc'] = str_replace("|", " ", $row['full_desc']);
			$row['cat_name'] = str_replace("|", " ", $row['cat_name']);
		}
		else {
			print "Incorrect columns separator.";
			exit;			
		}
		
		// Output the datafeed content
		print  
		$row['cat_name'] . $datafeed_separator . 
		$row['manufacturer'] . $datafeed_separator . 
		'' . $datafeed_separator . 
		$row['productid'] . $datafeed_separator . 
		$row['prod_name'] . $datafeed_separator . 
		$row['full_desc'] . $datafeed_separator . 
		$row['prod_url'] . $datafeed_separator . 
		$row['prod_image'] . $datafeed_separator . 
		$row['prod_price'] . $datafeed_separator . 
		$datafeed_currency . "\n";	
}
exit;
###################################################################


##### Functions ########################################################

// Function to return the Product URL based on your product ID
function smfeed_get_product_url($prod_id){		
	return "http://" . $_SERVER['HTTP_HOST'] . "/index.php?l=product_detail&p=" . $prod_id;
}

// Function to return the Product Image based on your product image or optionally Product ID
function smfeed_get_product_image($prod_image){	
	return "http://" . $_SERVER['HTTP_HOST'] . "/images/products/" . $prod_image;	
}

function smfeed_clean_description($string){

	$search = array (
		"'<html>'i",
		"'</html>'i",
		"'<body>'i",
		"'</body>'i",
		"'<head>.*?</head>'si",
		"'<!DOCTYPE[^>]*?>'si"
		); 
		
	$replace = array (
		"",
		"",
		"",
		"",
		"",
		""
		); 
		
	$text = preg_replace ($search, $replace, $string);
	return $text;

}

function smfeed_replace_not_in_tags($find_str, $replace_str, $string) {
	
	$find = array($find_str);
	$replace = array($replace_str);	
	preg_match_all('#[^>]+(?=<)|[^>]+$#', $string, $matches, PREG_SET_ORDER);	
	foreach ($matches as $val) {	
		if (trim($val[0]) != "") {
			$string = str_replace($val[0], str_replace($find, $replace, $val[0]), $string);
		}
	}	
	return $string;
}

###################################################################

?>